2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]]
22 TMP="$GIT_DIR/.git-stash.$$"
23 TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
24 trap 'rm -f "$TMP-"* "$TMPindex"' 0
28 if git config --get-colorbool color.interactive; then
29 help_color="$(git config --get-color color.interactive.help 'red bold')"
30 reset_color="$(git config --get-color '' reset)"
37 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
38 git diff-files --quiet --ignore-submodules &&
39 (test -z "$untracked" || test -z "$(untracked_files)")
43 excl_opt=--exclude-standard
44 test "$untracked" = "all" && excl_opt=
45 git ls-files -o -z $excl_opt
51 die "$(gettext "git stash clear with parameters is unimplemented")"
53 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
55 git update-ref -d $ref_stash $current
63 git update-index -q --refresh
69 # state of the base commit
70 if b_commit=$(git rev-parse --verify HEAD)
72 head=$(git rev-list --oneline -n 1 HEAD --)
74 die "$(gettext "You do not have the initial commit yet")"
77 if branch=$(git symbolic-ref -q HEAD)
79 branch=${branch#refs/heads/}
83 msg=$(printf '%s: %s' "$branch" "$head")
86 i_tree=$(git write-tree) &&
87 i_commit=$(printf 'index on %s\n' "$msg" |
88 git commit-tree $i_tree -p $b_commit) ||
89 die "$(gettext "Cannot save the current index state")"
91 if test -n "$untracked"
93 # Untracked files are stored by themselves in a parentless commit, for
94 # ease of unpacking later.
97 export GIT_INDEX_FILE="$TMPindex"
99 git update-index -z --add --remove --stdin &&
100 u_tree=$(git write-tree) &&
101 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
103 ) ) || die "Cannot save the untracked files"
105 untracked_commit_option="-p $u_commit";
107 untracked_commit_option=
110 if test -z "$patch_mode"
113 # state of the working tree
115 git read-tree --index-output="$TMPindex" -m $i_tree &&
116 GIT_INDEX_FILE="$TMPindex" &&
117 export GIT_INDEX_FILE &&
118 git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
122 die "$(gettext "Cannot save the current worktree state")"
126 rm -f "$TMP-index" &&
127 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
129 # find out what the user wants
130 GIT_INDEX_FILE="$TMP-index" \
131 git add--interactive --patch=stash -- &&
133 # state of the working tree
134 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
135 die "$(gettext "Cannot save the current worktree state")"
137 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
138 test -s "$TMP-patch" ||
139 die "$(gettext "No changes selected")"
141 rm -f "$TMP-index" ||
142 die "$(gettext "Cannot remove temporary index (can't happen)")"
147 if test -z "$stash_msg"
149 stash_msg=$(printf 'WIP on %s' "$msg")
151 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
153 w_commit=$(printf '%s\n' "$stash_msg" |
154 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
155 die "$(gettext "Cannot record working tree state")"
173 # only default to keep if we don't already have an override
174 test -z "$keep_index" && keep_index=t
179 -u|--include-untracked)
191 # TRANSLATORS: $option is an invalid option, like
192 # `--blah-blah'. The 7 spaces at the beginning of the
193 # second line correspond to "error: ". So you should line
194 # up the second line with however many characters the
195 # translation of "error: " takes in your language. E.g. in
198 # $ git stash save --blah-blah 2>&1 | head -n 2
199 # error: unknown option for 'stash save': --blah-blah
200 # To provide a message, use git stash save -- '--blah-blah'
201 eval_gettextln "$("error: unknown option for 'stash save': \$option
202 To provide a message, use git stash save -- '\$option'")"
212 if test -n "$patch_mode" && test -n "$untracked"
214 die "Can't use --patch and --include-untracked or --all at the same time"
219 git update-index -q --refresh
222 say "$(gettext "No local changes to save")"
225 test -f "$GIT_DIR/logs/$ref_stash" ||
226 clear_stash || die "$(gettext "Cannot initialize stash")"
228 create_stash "$stash_msg" $untracked
230 # Make sure the reflog for stash is kept.
231 : >>"$GIT_DIR/logs/$ref_stash"
233 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
234 die "$(gettext "Cannot save the current status")"
235 say Saved working directory and index state "$stash_msg"
237 if test -z "$patch_mode"
239 git reset --hard ${GIT_QUIET:+-q}
240 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
241 if test -n "$untracked"
243 git clean --force --quiet -d $CLEAN_X_OPTION
246 if test "$keep_index" = "t" && test -n $i_tree
248 git read-tree --reset -u $i_tree
251 git apply -R < "$TMP-patch" ||
252 die "$(gettext "Cannot remove worktree changes")"
254 if test "$keep_index" != "t"
262 git rev-parse --verify $ref_stash >/dev/null 2>&1
266 have_stash || return 0
267 git log --format="%gd: %gs" -g "$@" $ref_stash --
271 assert_stash_like "$@"
273 git diff ${FLAGS:---stat} $b_commit $w_commit
277 # Parses the remaining options looking for flags and
278 # at most one revision defaulting to ${ref_stash}@{0}
281 # Derives related tree and commit objects from the
282 # revision, if one is found.
284 # stash records the work tree, and is a merge between the
285 # base commit (first parent) and the index tree (second parent).
287 # REV is set to the symbolic version of the specified stash-like commit
288 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
289 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
290 # s is set to the SHA1 of the stash commit
291 # w_commit is set to the commit containing the working tree
292 # b_commit is set to the base commit
293 # i_commit is set to the commit containing the index tree
294 # u_commit is set to the commit containing the untracked files tree
295 # w_tree is set to the working tree
296 # b_tree is set to the base tree
297 # i_tree is set to the index tree
298 # u_tree is set to the untracked files tree
300 # GIT_QUIET is set to t if -q is specified
301 # INDEX_OPTION is set to --index if --index is specified.
302 # FLAGS is set to the remaining flags
305 # * too many revisions specified
306 # * no revision is specified and there is no stash stack
307 # * a revision is specified which cannot be resolve to a SHA1
308 # * a non-existent stash reference is specified
311 parse_flags_and_rev()
313 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
329 REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
342 FLAGS="${FLAGS}${FLAGS:+ }$opt"
351 have_stash || die "$(gettext "No stash found.")"
352 set -- ${ref_stash}@{0}
358 die "$(eval_gettext "Too many revisions specified: \$REV")"
362 REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || {
364 die "$(eval_gettext "\$reference is not valid reference")"
367 i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
368 set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
376 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
379 u_commit=$(git rev-parse --quiet --verify $REV^3 2>/dev/null) &&
380 u_tree=$(git rev-parse $REV^3: 2>/dev/null)
385 parse_flags_and_rev "$@"
386 test -n "$IS_STASH_LIKE"
389 assert_stash_like() {
390 is_stash_like "$@" || {
392 die "$(eval_gettext "'\$args' is not a stash-like commit")"
397 is_stash_like "$@" && test -n "$IS_STASH_REF"
401 is_stash_ref "$@" || {
403 die "$(eval_gettext "'\$args' is not a stash reference")"
409 assert_stash_like "$@"
411 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
413 # current index state
414 c_tree=$(git write-tree) ||
415 die "$(gettext "Cannot apply a stash in the middle of a merge")"
417 unstashed_index_tree=
418 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
419 test "$c_tree" != "$i_tree"
421 git diff-tree --binary $s^2^..$s^2 | git apply --cached
423 die "$(gettext "Conflicts in index. Try without --index.")"
424 unstashed_index_tree=$(git write-tree) ||
425 die "$(gettext "Could not save index tree")"
431 GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
432 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
434 die 'Could not restore untracked files from stash'
438 GITHEAD_$w_tree='Stashed changes' &&
439 GITHEAD_$c_tree='Updated upstream' &&
440 GITHEAD_$b_tree='Version stash was based on' &&
441 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
444 if test -n "$GIT_QUIET"
446 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
448 if git merge-recursive $b_tree -- $c_tree $w_tree
451 if test -n "$unstashed_index_tree"
453 git read-tree "$unstashed_index_tree"
456 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
457 git read-tree --reset $c_tree &&
458 git update-index --add --stdin <"$a" ||
459 die "$(gettext "Cannot unstage modified files")"
463 if test -n "$GIT_QUIET"
465 squelch='>/dev/null 2>&1'
467 (cd "$START_DIR" && eval "git status $squelch") || :
469 # Merge conflict; keep the exit status from merge-recursive
471 if test -n "$INDEX_OPTION"
473 gettextln "Index was not unstashed." >&2
480 assert_stash_ref "$@"
487 assert_stash_ref "$@"
489 git reflog delete --updateref --rewrite "${REV}" &&
490 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
491 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
493 # clear_stash if we just dropped the last stash entry
494 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
498 test -n "$1" || die "$(gettext "No branch name specified")"
503 assert_stash_like "$@"
505 git checkout -b $branch $REV^ &&
506 apply_stash "$@" && {
507 test -z "$IS_STASH_REF" || drop_stash "$@"
511 PARSE_CACHE='--not-parsed'
512 # The default command is "save" if nothing but options are given
518 *) seen_non_option=t; break ;;
522 test -n "$seen_non_option" || set "save" "$@"
547 if test $# -gt 0 && test "$1" = create
551 create_stash "$*" && echo "$w_commit"
569 say "$(gettext "(To restore them type \"git stash apply\")")"